package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLSpace_userImport) ENABLED START ***/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLSpace extends JNIObject implements IISLSingleSpaceSetMethods, IISLSingleSpaceMapMethods {
	
	/* @generated */
	protected ISLSpace(long ptr) {
		/*** PROTECTED REGION ID(ISLSpace_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLSpace build(long ptr) {
		return new ISLSpace(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLSpace_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}

	public static ISLSpace alloc(int nparam, int n_in, int n_out) {
		return ISLSpace.alloc(ISLContext.getInstance(), nparam, n_in, n_out);
	}

	public static ISLSpace allocSetSpace(int nparam, int dim) {
		return ISLSpace.allocSetSpace(ISLContext.getInstance(), nparam, dim);
	}

	/**
	 * Given a space representing dimensions of a set, this function returns a
	 * new space designed for creating maps, and with same dimensions as input
	 * and output.
	 * 
	 */
	public static ISLSpace idMapDimFromSetDim(ISLSpace origSetDims) {
		int nParam = (int) origSetDims.dim(ISLDimType.isl_dim_param);
		int nbDim = (int) origSetDims.dim(ISLDimType.isl_dim_set);

		//init
		ISLSpace idMapDims = ISLSpace.alloc(nParam, nbDim, nbDim);

		//simply copy parameters
		for (int i = 0; i < nParam; i++) {
			String name = origSetDims.getDimName(ISLDimType.isl_dim_param, i);
			if (name != null) {
				idMapDims = idMapDims.setDimName(ISLDimType.isl_dim_param, i,
						name);
			}
		}

		//in and out dimensions are the same.
		for (int i = 0; i < nbDim; i++) {
			String name = origSetDims.getDimName(ISLDimType.isl_dim_set, i);
			if (name != null) {
				idMapDims = idMapDims
						.setDimName(ISLDimType.isl_dim_in, i, name);
				idMapDims = idMapDims.setDimName(ISLDimType.isl_dim_out, i,
						name);
			}
		}

		//set tuple name
		String tupleName = origSetDims.getTupleName(ISLDimType.isl_dim_set);
		if (tupleName != null) {
			idMapDims = idMapDims.setTupleName(ISLDimType.isl_dim_in, tupleName);
			idMapDims = idMapDims.setTupleName(ISLDimType.isl_dim_out, tupleName);
		}

		return idMapDims;
	}

	/**
	 * This function is used to isolate parameters from a given space, and
	 * return a new space for creating "map" with only parameters. For example,
	 * given the space [M,N] -> {[i,j] -> [i',j']} the function will return
	 * [M,N] -> {[] -> []}.
	 * 
	 * @param origSpace
	 * @return
	 */
	public static ISLSpace copySpaceParamsForMap(ISLSpace origSpace) {
		return copySpaceParams(origSpace, false);
	}

	/**
	 * This function is used to isolate parameters from a given space, and
	 * return a new space for creating "set" with only parameters. For example,
	 * given the space [M,N] -> {[i,j]} the function will return [M,N] -> {[]}.
	 * 
	 * @param origSpace
	 * @return
	 */
	public static ISLSpace copySpaceParamsForSet(ISLSpace origSpace) {
		return copySpaceParams(origSpace, true);
	}

	private static ISLSpace copySpaceParams(ISLSpace origSpace,
			boolean set) {
		int nParam = (int) origSpace.dim(ISLDimType.isl_dim_param);
		ISLSpace paramOnlySpace = set
				? ISLSpace.allocSetSpace(nParam, 0)
				: ISLSpace.alloc(nParam, 0, 0);
		//simply copy parameters
		for (int i = 0; i < nParam; i++) {
			String name = origSpace.getDimName(ISLDimType.isl_dim_param, i);
			if (name != null) {
				paramOnlySpace = paramOnlySpace.setDimName(
						ISLDimType.isl_dim_param, i, name);
			}
		}
		return paramOnlySpace;
	}
	
	/**
	 * Given a set space, builds a map in which 'in' and 'out' dimensions are
	 * equals from 0 to 'dim'-1, and 'in' > 'out' for dimension 'dim'. For
	 * instance, given the space { [i,j,k] } and dim=2, this method builds the
	 * map { [i,j,k] -> [i',j',k'] : i' = i && j > j' }
	 * 
	 * @param dim
	 * @return
	 */
	public ISLMap lexLTAt(int dim) {
		if (!this.isSetSpace()) 
			throw new IllegalArgumentException("This method applies only on set spaces");
		if (dim < 0) 
			throw new IllegalArgumentException("dim has to be greater than 0");
		
		ISLSpace space = ISLSpace.idMapDimFromSetDim(this.copy());
		int size = space.dim(ISLDimType.isl_dim_set);
		if (dim > size) dim = size;
		ISLBasicMap res = ISLBasicMap.buildUniverse(space.copy());
		for (int i = 0; i < dim; i++) {
			res = res.addConstraint(ISLConstraint.dimEqual(space.copy(), i));
		}
		res = res.addConstraint(ISLConstraint.dimLessThan(space.copy(), dim, 1));
		return res.toMap();
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_space_alloc 
	 * 
	 * @generated
	**/
	 public static ISLSpace alloc(ISLContext ctx, int nparam, int n_in, int n_out) { 
		/*** PROTECTED REGION ID(static_isl_space_alloc) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_space_alloc(getNativePtr(ctx), nparam, n_in, n_out));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_params_alloc 
	 * 
	 * @generated
	**/
	 public static ISLSpace allocParamSpace(ISLContext ctx, int nparam) { 
		/*** PROTECTED REGION ID(static_isl_space_params_alloc) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_space_params_alloc(getNativePtr(ctx), nparam));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_set_alloc 
	 * 
	 * @generated
	**/
	 public static ISLSpace allocSetSpace(ISLContext ctx, int nparam, int dim) { 
		/*** PROTECTED REGION ID(static_isl_space_set_alloc) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_space_set_alloc(getNativePtr(ctx), nparam, dim));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_map_from_domain_and_range 
	 * 
	@take domain range
	 * @generated
	**/
	 public static ISLSpace buildMapSpaceFromDomainAndRange(ISLSpace domain, ISLSpace range) { 
		/*** PROTECTED REGION ID(static_isl_space_map_from_domain_and_range) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(domain, range);
			try {
				res = ISLSpace.build(ISLNative.isl_space_map_from_domain_and_range(getNativePtr(domain), getNativePtr(range)));
			} finally {
				taken(domain);
				taken(range);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_local_space_from_space 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLLocalSpace toLocalSpace() {
		/*** PROTECTED REGION ID(isl_local_space_from_space) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLLocalSpace.build(ISLNative.isl_local_space_from_space(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_space_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_space_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_copy 
	 * 
	 * @generated
	**/
	public ISLSpace copy() {
		/*** PROTECTED REGION ID(isl_space_copy) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_space_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_space_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_space_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_space_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_is_params 
	 * 
	 * @generated
	**/
	public boolean isParamSpace() {
		/*** PROTECTED REGION ID(isl_space_is_params) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_is_params(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_is_set 
	 * 
	 * @generated
	**/
	public boolean isSetSpace() {
		/*** PROTECTED REGION ID(isl_space_is_set) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_is_set(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_is_map 
	 * 
	 * @generated
	**/
	public boolean isMapSpace() {
		/*** PROTECTED REGION ID(isl_space_is_map) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_is_map(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_is_equal 
	 * 
	 * @generated
	**/
	public boolean isEqual(ISLSpace space2) {
		/*** PROTECTED REGION ID(isl_space_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_is_equal(getNativePtr(this), getNativePtr(space2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_is_domain 
	 * 
	 * @generated
	**/
	public boolean isDomain(ISLSpace space2) {
		/*** PROTECTED REGION ID(isl_space_is_domain) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_is_domain(getNativePtr(this), getNativePtr(space2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_is_range 
	 * 
	 * @generated
	**/
	public boolean isRange(ISLSpace space2) {
		/*** PROTECTED REGION ID(isl_space_is_range) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_is_range(getNativePtr(this), getNativePtr(space2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_set_dim_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace setDimName(ISLDimType type, int pos, String name) {
		/*** PROTECTED REGION ID(isl_space_set_dim_name) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_set_dim_name(getNativePtr(this), type.getValue(), pos, name));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_get_dim_name 
	 * 
	 * @generated
	**/
	public String getDimName(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_space_get_dim_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_get_dim_name(getNativePtr(this), type.getValue(), pos);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_has_dim_name 
	 * 
	 * @generated
	**/
	public boolean hasDimName(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_space_has_dim_name) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_has_dim_name(getNativePtr(this), type.getValue(), pos) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_find_dim_by_name 
	 * 
	 * @generated
	**/
	public int findDimByName(ISLDimType type, String name) {
		/*** PROTECTED REGION ID(isl_space_find_dim_by_name) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_find_dim_by_name(getNativePtr(this), type.getValue(), name);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_set_tuple_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace setTupleName(ISLDimType type, String s) {
		/*** PROTECTED REGION ID(isl_space_set_tuple_name) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_set_tuple_name(getNativePtr(this), type.getValue(), s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_get_tuple_name 
	 * 
	 * @generated
	**/
	public String getTupleName(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_space_get_tuple_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_get_tuple_name(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_has_tuple_name 
	 * 
	 * @generated
	**/
	public int hasTupleName(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_space_has_tuple_name) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_has_tuple_name(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace domain() {
		/*** PROTECTED REGION ID(isl_space_domain) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace range() {
		/*** PROTECTED REGION ID(isl_space_range) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_from_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace toMapSpaceFromSetSpaceAsDomain() {
		/*** PROTECTED REGION ID(isl_space_from_domain) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_from_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_from_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace toMapSpaceFromSetSpaceAsRange() {
		/*** PROTECTED REGION ID(isl_space_from_range) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_from_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_domain_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace domainMap() {
		/*** PROTECTED REGION ID(isl_space_domain_map) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_domain_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_range_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace rangeMap() {
		/*** PROTECTED REGION ID(isl_space_range_map) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_range_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_params 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace params() {
		/*** PROTECTED REGION ID(isl_space_params) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_params(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_set_from_params 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace toSetSpaceFromParamSpace() {
		/*** PROTECTED REGION ID(isl_space_set_from_params) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_set_from_params(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_reverse 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace reverse() {
		/*** PROTECTED REGION ID(isl_space_reverse) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_reverse(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_join 
	 * 
	 * @take this right
	 * @generated
	**/
	public ISLSpace join(ISLSpace right) {
		/*** PROTECTED REGION ID(isl_space_join) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this, right);
			try {
				res = ISLSpace.build(ISLNative.isl_space_join(getNativePtr(this), getNativePtr(right)));
			} finally {
				taken(this);
				taken(right);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_align_params 
	 * 
	 * @take this space2
	 * @generated
	**/
	public ISLSpace alignParams(ISLSpace space2) {
		/*** PROTECTED REGION ID(isl_space_align_params) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this, space2);
			try {
				res = ISLSpace.build(ISLNative.isl_space_align_params(getNativePtr(this), getNativePtr(space2)));
			} finally {
				taken(this);
				taken(space2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_insert_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace insertDims(ISLDimType type, int pos, int n) {
		/*** PROTECTED REGION ID(isl_space_insert_dims) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_insert_dims(getNativePtr(this), type.getValue(), pos, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_add_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace addDims(ISLDimType type, int n) {
		/*** PROTECTED REGION ID(isl_space_add_dims) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_add_dims(getNativePtr(this), type.getValue(), n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_drop_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace dropDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_space_drop_dims) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_drop_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_move_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace moveDims(ISLDimType dst_type, int dst_pos, ISLDimType src_type, int src_pos, int n) {
		/*** PROTECTED REGION ID(isl_space_move_dims) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_move_dims(getNativePtr(this), dst_type.getValue(), dst_pos, src_type.getValue(), src_pos, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_map_from_set 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace toMapSpaceFromSetSpace() {
		/*** PROTECTED REGION ID(isl_space_map_from_set) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_map_from_set(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_zip 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace zip() {
		/*** PROTECTED REGION ID(isl_space_zip) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_zip(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_is_wrapping 
	 * 
	 * @generated
	**/
	public boolean isWrapping() {
		/*** PROTECTED REGION ID(isl_space_is_wrapping) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_is_wrapping(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_domain_is_wrapping 
	 * 
	 * @generated
	**/
	public boolean domainIsWrapping() {
		/*** PROTECTED REGION ID(isl_space_domain_is_wrapping) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_domain_is_wrapping(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_range_is_wrapping 
	 * 
	 * @generated
	**/
	public boolean rangeIsWrapping() {
		/*** PROTECTED REGION ID(isl_space_range_is_wrapping) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_range_is_wrapping(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_can_curry 
	 * 
	 * @generated
	**/
	public boolean canCurry() {
		/*** PROTECTED REGION ID(isl_space_can_curry) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_can_curry(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_can_range_curry 
	 * 
	 * @generated
	**/
	public boolean canRangeCurry() {
		/*** PROTECTED REGION ID(isl_space_can_range_curry) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_can_range_curry(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_can_uncurry 
	 * 
	 * @generated
	**/
	public boolean canUncurry() {
		/*** PROTECTED REGION ID(isl_space_can_uncurry) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_can_uncurry(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_wrap 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace wrap() {
		/*** PROTECTED REGION ID(isl_space_wrap) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_wrap(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_unwrap 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace unwrap() {
		/*** PROTECTED REGION ID(isl_space_unwrap) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_unwrap(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_curry 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace curry() {
		/*** PROTECTED REGION ID(isl_space_curry) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_curry(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_uncurry 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace uncurry() {
		/*** PROTECTED REGION ID(isl_space_uncurry) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_uncurry(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_range_curry 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSpace rangeCurry() {
		/*** PROTECTED REGION ID(isl_space_range_curry) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSpace.build(ISLNative.isl_space_range_curry(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_is_product 
	 * 
	 * @generated
	**/
	public boolean isProduct() {
		/*** PROTECTED REGION ID(isl_space_is_product) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_space_is_product(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_space_product 
	 * 
	 * @take this right
	 * @generated
	**/
	public ISLSpace product(ISLSpace right) {
		/*** PROTECTED REGION ID(isl_space_product) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters(this, right);
			try {
				res = ISLSpace.build(ISLNative.isl_space_product(getNativePtr(this), getNativePtr(right)));
			} finally {
				taken(this);
				taken(right);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_lex_lt 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap toLexLTMap() {
		/*** PROTECTED REGION ID(isl_map_lex_lt) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_lex_lt(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_lex_le 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap toLexLEMap() {
		/*** PROTECTED REGION ID(isl_map_lex_le) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_lex_le(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_lex_gt 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap toLexGTMap() {
		/*** PROTECTED REGION ID(isl_map_lex_gt) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_lex_gt(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_lex_ge 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap toLexGEMap() {
		/*** PROTECTED REGION ID(isl_map_lex_ge) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_lex_ge(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_lex_lt_first 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap toLexLTfirstMap(int n) {
		/*** PROTECTED REGION ID(isl_map_lex_lt_first) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_lex_lt_first(getNativePtr(this), n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_lex_le_first 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap toLexLEfirstMap(int n) {
		/*** PROTECTED REGION ID(isl_map_lex_le_first) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_lex_le_first(getNativePtr(this), n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_lex_gt_first 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap toLexGTfirstMap(int n) {
		/*** PROTECTED REGION ID(isl_map_lex_gt_first) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_lex_gt_first(getNativePtr(this), n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_lex_ge_first 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap toLexGEfirstMap(int n) {
		/*** PROTECTED REGION ID(isl_map_lex_ge_first) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_lex_ge_first(getNativePtr(this), n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLSpace_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
